import { createActions } from 'redux-actions';

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _objectSpread(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};
    var ownKeys = Object.keys(source);

    if (typeof Object.getOwnPropertySymbols === 'function') {
      ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) {
        return Object.getOwnPropertyDescriptor(source, sym).enumerable;
      }));
    }

    ownKeys.forEach(function (key) {
      _defineProperty(target, key, source[key]);
    });
  }

  return target;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

var STATES = ['REQUESTED', 'RECEIVED', 'REJECTED'];

var isPromise = function isPromise(value) {
  return Promise.resolve(value) === value;
};

var createActions$1 = function createActions$$1() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
    states: STATES,
    prefix: ''
  },
      _ref$states = _ref.states,
      states = _ref$states === void 0 ? STATES : _ref$states,
      _ref$prefix = _ref.prefix,
      prefix = _ref$prefix === void 0 ? '' : _ref$prefix;

  return function () {
    var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
      entity: ''
    },
        _ref2$entity = _ref2.entity,
        entity = _ref2$entity === void 0 ? '' : _ref2$entity;

    return function (actions) {
      return createActions(Object.entries(actions).reduce(function (acc, _ref3) {
        var _ref4 = _slicedToArray(_ref3, 2),
            k = _ref4[0],
            v = _ref4[1];

        return _objectSpread({}, acc, _defineProperty({}, k, isPromise(v) ? function () {
          return v;
        } : v), v && isPromise(v) && states.reduce(function (acc, curr) {
          return _objectSpread({}, acc, _defineProperty({}, "".concat(k, "/").concat(curr), undefined));
        }, {}));
      }, {}), {
        prefix: "".concat(prefix).concat(entity !== '' ? "".concat(prefix && '/').concat(entity) : '')
      });
    };
  };
};

export default createActions$1;
